
#include <windows.h>
#include <stdio.h>
#include "Yield.h"

#if defined (WIN32)
	#define IS_WIN32 TRUE
#else
	#define IS_WIN32 FALSE
#endif

#define IS_NT      IS_WIN32 && (BOOL)(GetVersion() < 0x80000000)
#define IS_WIN32S  IS_WIN32 && (BOOL)(!(IS_NT) && (LOBYTE(LOWORD(GetVersion()))<4))
#define IS_WIN95   (BOOL)(!(IS_NT) && !(IS_WIN32S)) && IS_WIN32

HINSTANCE hInst;   // current instance

LPCTSTR lpszAppName = "MyApp";
LPCTSTR lpszTitle   = "mciSetYieldProc()"; 


BOOL RegisterWin95( CONST WNDCLASS* lpwc );


int APIENTRY WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
                      LPTSTR lpCmdLine, int nCmdShow)
{
   MSG      msg;
   HWND     hWnd; 
   WNDCLASS wc;

   wc.style         = CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
   wc.lpfnWndProc   = (WNDPROC)WndProc;       
   wc.cbClsExtra    = 0;                      
   wc.cbWndExtra    = 0;                      
   wc.hInstance     = hInstance;              
   wc.hIcon         = LoadIcon (hInstance, lpszAppName); 
   wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
   wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
   wc.lpszMenuName  = lpszAppName;              
   wc.lpszClassName = lpszAppName;              

   if ( IS_WIN95 )
   {
      if ( !RegisterWin95( &wc ) )
         return( FALSE );
   }
   else if ( !RegisterClass( &wc ) )
      return( FALSE );

   hInst = hInstance; 

   hWnd = CreateWindow( lpszAppName, 
                        lpszTitle,    
                        WS_OVERLAPPEDWINDOW, 
                        CW_USEDEFAULT, 0, 
                        CW_USEDEFAULT, 0,  
                        NULL,              
                        NULL,              
                        hInstance,         
                        NULL               
                      );

   if ( !hWnd ) 
      return( FALSE );

   ShowWindow( hWnd, nCmdShow ); 
   UpdateWindow( hWnd );         

   while( GetMessage( &msg, NULL, 0, 0) )   
   {
      TranslateMessage( &msg ); 
      DispatchMessage( &msg );  
   }

   return( msg.wParam ); 
}


BOOL RegisterWin95( CONST WNDCLASS* lpwc )
{
	WNDCLASSEX wcex;

   wcex.style         = lpwc->style;
   wcex.lpfnWndProc   = lpwc->lpfnWndProc;
   wcex.cbClsExtra    = lpwc->cbClsExtra;
   wcex.cbWndExtra    = lpwc->cbWndExtra;
   wcex.hInstance     = lpwc->hInstance;
   wcex.hIcon         = lpwc->hIcon;
   wcex.hCursor       = lpwc->hCursor;
   wcex.hbrBackground = lpwc->hbrBackground;
   wcex.lpszMenuName  = lpwc->lpszMenuName;
   wcex.lpszClassName = lpwc->lpszClassName;

   // Added elements for Windows 95.
   //...............................
   wcex.cbSize = sizeof(WNDCLASSEX);
   wcex.hIconSm = LoadImage(wcex.hInstance, lpwc->lpszClassName, 
                            IMAGE_ICON, 16, 16,
                            LR_DEFAULTCOLOR );
			
   return RegisterClassEx( &wcex );
}

#define MSG_LEN          1024


char             msg[MSG_LEN+1];
HWND             hListBox = NULL;
MCIERROR         rc;
MCIDEVICEID      uDeviceId = 0;
MCI_OPEN_PARMS   open;
MCI_PLAY_PARMS   play;
UINT             uTimer;
UINT             nYieldProcCalled;

int CALLBACK MyYieldProc(MCIDEVICEID uDeviceId, DWORD dwData);


LRESULT CALLBACK WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
   BOOL      brc;   // tmp
   YIELDPROC yp = NULL;

   switch( uMsg )
   {
      case WM_CREATE :
              // Create ListBox
              //...............

              hListBox = CreateWindow( "LISTBOX", "",    
                                       WS_CHILD | LBS_NOTIFY | 
                                       WS_VSCROLL | WS_BORDER | 
                                       WS_VISIBLE | LBS_NOINTEGRALHEIGHT, 
                                       0, 0, 
                                       0, 0,  
                                       hWnd,              
                                       (HMENU)101,              
                                       hInst,         
                                       NULL );
              break;

      case WM_SIZE :
              MoveWindow( hListBox, 0, 0, 
                          LOWORD( lParam ), 
                          HIWORD( lParam ), TRUE );
              break;

      case WM_COMMAND :
              switch( LOWORD( wParam ) )
              {
                 case IDM_TEST:
                        {
                           SendMessage(hListBox, LB_RESETCONTENT, 0, 0);

                           // open device
                           //............

                           open.dwCallback       = (DWORD)hWnd;
                           open.lpstrDeviceType  = "waveaudio";
                           open.lpstrElementName = "sample2.wav";
                           open.lpstrAlias       = "song";

                           rc = mciSendCommand(0, MCI_OPEN, 
                                               MCI_OPEN_TYPE    | 
                                               MCI_OPEN_ELEMENT |
                                               MCI_OPEN_ALIAS,
                                               (DWORD)&open);

                           if (rc)
                           {
                               mciGetErrorString(rc, msg, MSG_LEN);
                               MessageBox(hWnd, msg, NULL, MB_ICONSTOP|MB_OK);
                               mciSendCommand(MCI_ALL_DEVICE_ID, MCI_CLOSE, 
                                              MCI_WAIT, (DWORD)NULL);
                               return(0);
                           }

                           // setup stuff
                           //............

                           uDeviceId = open.wDeviceID;

                           if ( uDeviceId != mciGetDeviceID("song") )
                           {
                               sprintf(msg, "Device Id mis-match %ld != %ld",
                                       uDeviceId, mciGetDeviceID("song") );
                               MessageBox(hWnd, msg, NULL, MB_ICONSTOP|MB_OK);
                               mciSendCommand(MCI_ALL_DEVICE_ID, MCI_CLOSE, 
                                              MCI_WAIT, (DWORD)NULL);
                               return(0);
                           }

                           play.dwCallback   = (DWORD)hWnd;
                           nYieldProcCalled  = 0;

                           // display Creator Task
                           //.....................

                           sprintf(msg, "Creater task handle = %d",
                                        mciGetCreatorTask(uDeviceId) );
                           SendMessage(hListBox, LB_ADDSTRING, 0, (LPARAM)msg);

                           // set yield proc address
                           //.......................
                           yp = mciGetYieldProc(uDeviceId, NULL);

                           brc = mciSetYieldProc(uDeviceId, MyYieldProc, (DWORD)NULL);
                           uTimer = SetTimer(hWnd, 1, 20, NULL);

                           // playback
                           //.........
                           rc = mciSendCommand(uDeviceId, 
                                               MCI_PLAY, 
                                               MCI_WAIT, 
                                               (DWORD)&play);

                           mciSendCommand(uDeviceId, MCI_CLOSE, 0, (DWORD)NULL);
                           KillTimer(hWnd, uTimer);

                           sprintf(msg, "MyYieldProc() function called %ld times", 
                                   nYieldProcCalled);
                           SendMessage(hListBox, LB_ADDSTRING, 0, (LPARAM)msg);

						   // Restore old yield proc.
						   //........................
                           mciSetYieldProc(uDeviceId, yp, (DWORD)NULL);
                        }
                        break;

                 case IDM_ABOUT :
                        DialogBox( hInst, "AboutBox", hWnd, About );
                        break;

                 case IDM_EXIT :
                        DestroyWindow(hWnd);
                        break;
              }
              break;

      case MM_MCINOTIFY:
              // close waveform-audio device
              //............................
              mciSendCommand(uDeviceId, MCI_CLOSE, 0, (DWORD)NULL);
              break;

      case WM_DESTROY :
              PostQuitMessage(0);
              break;

      default :
            return( DefWindowProc( hWnd, uMsg, wParam, lParam ) );
   }

   return( 0L );               
}


int CALLBACK MyYieldProc(MCIDEVICEID uDeviceId, DWORD dwData)
{
   nYieldProcCalled++;
   
   return(0);
}


LRESULT CALLBACK About( HWND hDlg,           
                        UINT message,        
                        WPARAM wParam,       
                        LPARAM lParam)
{
   switch (message) 
   {
       case WM_INITDIALOG: 
               return (TRUE);

       case WM_COMMAND:                              
               if (   LOWORD(wParam) == IDOK         
                   || LOWORD(wParam) == IDCANCEL)    
               {
                       EndDialog(hDlg, TRUE);        
                       return (TRUE);
               }
               break;
   }

   return (FALSE); 
}











